﻿Imports System.Runtime.InteropServices

Public Class BinaryCast

    Public Shared Function Int32ToSingle(i As Int32) As Single
        Dim int = GCHandle.Alloc({i}, GCHandleType.Pinned)
        Dim float(0) As Single
        Marshal.Copy(int.AddrOfPinnedObject(), float, 0, 1)
        int.Free()
        Return float(0)
    End Function


    Public Shared Function Int64ToDouble(i As Int64) As Double
        Dim int = GCHandle.Alloc({i}, GCHandleType.Pinned)
        Dim float(0) As Double
        Marshal.Copy(int.AddrOfPinnedObject(), float, 0, 1)
        int.Free()
        Return float(0)
    End Function

    Public Shared Function SingleToInt32(f As Single) As Int32
        Dim float = GCHandle.Alloc({f}, GCHandleType.Pinned)
        Dim int(0) As Int32
        Marshal.Copy(float.AddrOfPinnedObject(), int, 0, 1)
        float.Free()
        Return int(0)
    End Function

    Public Shared Function DoubleToInt64(f As Double) As Int64
        Dim float = GCHandle.Alloc({f}, GCHandleType.Pinned)
        Dim int(0) As Int64
        Marshal.Copy(float.AddrOfPinnedObject(), int, 0, 1)
        float.Free()
        Return int(0)
    End Function

    Public Shared Function ByteToSingle(b As Byte()) As Single
        Dim bptr = GCHandle.Alloc(b, GCHandleType.Pinned)
        Dim float(0) As Single
        Marshal.Copy(bptr.AddrOfPinnedObject(), float, 0, 1)
        bptr.Free()
        Return float(0)
    End Function

    Public Shared Function ByteToDouble(b As Byte()) As Double
        Dim bptr = GCHandle.Alloc(b, GCHandleType.Pinned)
        Dim float(0) As Double
        Marshal.Copy(bptr.AddrOfPinnedObject(), float, 0, 1)
        bptr.Free()
        Return float(0)
    End Function

    Public Shared Function SingleToByte(f As Single) As Byte()
        Dim float = GCHandle.Alloc({f}, GCHandleType.Pinned)
        Dim b(4 - 1) As Byte
        Marshal.Copy(float.AddrOfPinnedObject(), b, 0, 4)
        float.Free()
        Return b
    End Function

    Public Shared Function DoubleToByte(f As Double) As Byte()
        Dim float = GCHandle.Alloc({f}, GCHandleType.Pinned)
        Dim b(8 - 1) As Byte
        Marshal.Copy(float.AddrOfPinnedObject(), b, 0, 8)
        float.Free()
        Return b
    End Function

End Class
