﻿Imports System.IO
Imports FFTWSharp
Imports System.Runtime.InteropServices
Imports System.Threading

Module Module1

    Sub Main()
        'Console.WriteLine(a)
        'Console.WriteLine(BinaryCast.ByteToDouble({&H18, &H2D, &H44, &H54, &HFB, &H21, &H9, &H40}))
        'Console.WriteLine(BinaryCast.DoubleToInt64(Math.PI))
        'Console.WriteLine(BinaryCast.ByteToDouble(BinaryCast.DoubleToByte(Math.PI)))
        'Console.SetOut(New StreamWriter("a.csv"))
        test_VocalCut("a.wav", "d.wav")
        'test_VocalGet("a.wav", "d.wav")
        'test_write("my.wav")
        'test_read("test.wav")
        'test_fft("test.wav")
        'Console.Out.Flush()
        Console.ReadKey()
    End Sub


    Sub test_VocalGet(src As String, tg As String)
        Using fsrc As New FileStream(src, FileMode.Open, FileAccess.Read),
              ftg As New FileStream(tg, FileMode.Create, FileAccess.Write)
            Dim wr As New WaveReader(fsrc)
            wr.ReadHeader()
            Dim ww As New WaveWriter(ftg, wr.Header.SamplesPerSec)
            ww.WriteHeader()
            For i = 0 To wr.Header.DataSize / wr.Header.BlockAlign
                Dim s = wr.ReadSample()
                'Dim abs As Int16 = Math.Abs(CDbl(s(0)) - CDbl(s(1))) / 2
                ww.WriteStereoSample(Of Int16)(s(0) - (s(0) - s(1)) / 2, s(1) - (s(1) - s(0)) / 2)
            Next
            ww.WriteHeader()
        End Using
    End Sub

    Sub test_VocalCut(src As String, tg As String)
        Using fsrc As New FileStream(src, FileMode.Open, FileAccess.Read),
              ftg As New FileStream(tg, FileMode.Create, FileAccess.Write)
            Dim wr As New WaveReader(fsrc)
            wr.ReadHeader()
            Dim ww As New WaveWriter(ftg, wr.Header.SamplesPerSec)
            ww.WriteHeader()
            Dim samples = wr.Header.DataSize / wr.Header.BlockAlign
            Dim data0(samples - 1) As Int16, data1(samples - 1) As Int16
            For i = 0 To samples - 1
                Dim s = wr.ReadSample()
                data0(i) = (s(0) - s(1)) / 2
                data1(i) = (s(1) - s(0)) / 2
            Next
            ww.WriteStereoSample(data0, data1)
            ww.WriteHeader()
        End Using
    End Sub

    Sub test_header(fn As String)
        Using fs As New FileStream(fn, FileMode.Open, FileAccess.Read)
            Dim wh = WaveHeader.Read(fs)
            Console.WriteLine(wh)
            wh.Save(New FileStream("header.wav", FileMode.Create, FileAccess.Write))
        End Using
    End Sub

    Sub test_read(fn As String)
        Using fs As New FileStream(fn, FileMode.Open, FileAccess.Read)
            Dim wr As New WaveReader(fs)
            wr.SeekTime(0.5)
            'wr.ReadHeader()
            For i = 0 To 100 'wr.Header.DataSize / wr.Header.BlockAlign
                Dim s = wr.ReadSample()
                Console.WriteLine("{0}*", New String(" "c, (s(0) + 1) * 25))
                'Console.WriteLine("{0}, {1}", i, s(0), s(1))
            Next
        End Using
    End Sub

    Sub test_fft(fn As String)
        Using fs As New FileStream(fn, FileMode.Open, FileAccess.Read)
            Dim wr As New WaveReader(fs)
            Dim sw As New Stopwatch()
            sw.Start()
            Do While True
                wr.SeekTime(sw.Elapsed.TotalSeconds)
                Console.Clear()
                Const fftsize = 1024
                Dim data0(fftsize - 1) As Double
                Dim data1(fftsize - 1) As Double
                For i = 0 To fftsize - 1
                    Dim s = wr.ReadSample()
                    data0(i) = s(0)
                    data1(i) = s(1)
                Next
                Dim ptr = fftw.malloc(fftsize * 8)
                Marshal.Copy(data0, 0, ptr, data0.Length)
                Dim carray As New fftw_complexarray(fftsize)
                Dim fftw_plan = fftw.dft_r2c_1d(fftsize, ptr, carray.Handle, fftw_flags.Estimate)
                fftw.execute(fftw_plan)
                fftw.free(ptr)
                Dim cdata(fftsize * 2 - 1) As Double
                Marshal.Copy(carray.Handle, cdata, 0, cdata.Length)
                For i = 0 To fftsize - 1
                    Dim real = cdata(i * 2)
                    Dim imag = cdata(i * 2 + 1)
                    Dim A = 2 * Math.Sqrt(real * real + imag * imag) / fftsize
                    If A * 50 >= 1 AndAlso A <= 1 Then
                        Console.WriteLine(New String("|"c, (A) * 50))
                    End If
                    'If A > 0.1 Then
                    'Console.WriteLine("{0}Hz: {1}", (i + 1) / fftsize * wr.Header.SamplesPerSec, A)
                    'End If
                Next
                'Thread.Sleep(100)
                'Console.ReadKey()
                If fs.Length - fs.Position < wr.Header.BlockAlign Then
                    sw.Stop()
                    sw.Reset()
                    sw.Start()
                End If
            Loop
        End Using

    End Sub

    Sub test_write(fn As String)
        Using fs As New FileStream(fn, FileMode.Create, FileAccess.Write)
            Dim ww As New WaveWriter(fs, 48000)
            'freq.addFreq(697)
            'freq.addFreq(770)
            'freq.addFreq(852)
            'freq.addFreq(941)
            'freq.addFreq(1209)
            'freq.addFreq(1336)
            'freq.addFreq(1477)
            'freq.addFreq(1663)
            'freq.addFrequency(2000, 0.5)
            'freq.addFrequency(3000, 0.5)
            'freq.addFrequency(2000, 1, 0.5 / 2000)
            'freq.addFrequency(3000)
            'freq.addFrequency(4000)
            'freq.addFrequency(5000)
            'freq.addFrequency(6000)
            'freq.addFrequency(7000)
            'freq.addFrequency(8000)
            Dim sig As New SineGenerator()
            sig.addFrequency(440, 0.5)
            ww.GenerateStereoSample(1, 0, Function(t As Double) As Single
                                              Return sig.Invoke(t)
                                          End Function, 0,
                                           Function(t As Double) As Single
                                               Return sig.Invoke(t)
                                           End Function)
            Dim sqg As New SquareGenerator()
            sqg.addFrequency(440, 0.5)
            ww.GenerateStereoSample(1, 0, Function(t As Double) As Single
                                              Return sqg.Invoke(t)
                                          End Function, 0,
                                           Function(t As Double) As Single
                                               Return sqg.Invoke(t)
                                           End Function)
            Dim tg As New TriGenerator()
            tg.addFrequency(440, 0.5)
            ww.GenerateStereoSample(1, 0, Function(t As Double) As Single
                                              Return tg.Invoke(t)
                                          End Function, 0,
                                           Function(t As Double) As Single
                                               Return tg.Invoke(t)
                                           End Function)
            Dim rg As New RandomGenerator()
            ww.GenerateStereoSample(1, 0, Function(t As Double) As Single
                                              Return rg.Invoke(t)
                                          End Function, 0,
                                         Function(t As Double) As Single
                                             Return rg.Invoke(t)
                                         End Function)
        End Using
    End Sub

End Module
