﻿Imports System.IO

Public Class WaveReader

    Public Header As WaveHeader = Nothing
    Private _s As Stream

    Sub New(s As Stream)
        _s = s
    End Sub

    Public Sub ReadHeader()
        If Header IsNot Nothing Then
            Return
            'Dim curr = _s.Position
            '_s.Seek(0, SeekOrigin.Begin)
            'Header = WaveHeader.Read(_s)
            '_s.Seek(curr, SeekOrigin.Begin)
        Else
            Header = WaveHeader.Read(_s)
        End If
    End Sub

    Public Sub SeekSample(sample As Integer)
        ReadHeader()
        _s.Seek(Header.Length() + Header.BlockAlign * sample, SeekOrigin.Begin)
    End Sub

    Public Sub SeekTime(t As Double)
        ReadHeader()
        Dim sample As Integer = t * Header.SamplesPerSec
        SeekSample(sample)
    End Sub

    Private Function ReadData() As Double
        If Header.BitsPerSample = 8 AndAlso Header.FormatTag = 1 Then '8bits PCM
            Return _s.ReadByte()
        ElseIf Header.BitsPerSample = 16 AndAlso Header.FormatTag = 1 Then '16bits PCM
            Dim data As Int16 = 0
            data += CShort(_s.ReadByte())
            data += CShort(_s.ReadByte()) << 8
            Return data
        ElseIf Header.BitsPerSample = 24 AndAlso Header.FormatTag = 1 Then '24 bits PCM
            Dim data As Int32 = 0
            data += CShort(_s.ReadByte())
            data += CShort(_s.ReadByte()) << 8
            data += CShort(_s.ReadByte()) << 16
            Return data
        ElseIf Header.BitsPerSample = 32 AndAlso Header.FormatTag = 3 Then '32bits IEEE Float
            Dim data(4 - 1) As Byte
            Dim read = 0
            Do While read < 4
                read += _s.Read(data, read, 4 - read)
            Loop
            Return BinaryCast.ByteToSingle(data)
        Else
            Throw New NotImplementedException(Header.BitsPerSample)
        End If
    End Function

    Public Function ReadSample() As Double()
        ReadHeader()
        Dim sample(Header.Channels - 1) As Double
        For i = 0 To Header.Channels - 1
            sample(i) = ReadData()
        Next
        Return sample
    End Function

End Class
